using CallCenterApi.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.IO;
using System.Linq;
using System.Text;

namespace CallCenterApi.DAL
{
    /// <summary>
    /// 数据访问类:submit_case_process_info
    /// </summary>
    public partial class submit_case_process_info
    {
        public submit_case_process_info()
        { }
        #region  BasicMethod

        /// <summary>
        /// 得到最大ID
        /// </summary>
        public int GetMaxId()
        {
            return DbHelperSQL.GetMaxID("F_ID", "submit_case_process_info");
        }

        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_ID)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from submit_case_process_info");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.submit_case_process_info model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into submit_case_process_info(");
            strSql.Append("CASE_SERIAL,AREA_CODE,PROCESS_ID,TACHE_NAME,DEPT_NAME,PROCESS_TIME,PROCESS_NAME,PROCESS_NOTE,CreateTime)");
            strSql.Append(" values (");
            strSql.Append("@CASE_SERIAL,@AREA_CODE,@PROCESS_ID,@TACHE_NAME,@DEPT_NAME,@PROCESS_TIME,@PROCESS_NAME,@PROCESS_NOTE,@CreateTime)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@CASE_SERIAL", SqlDbType.NVarChar,50),
                    new SqlParameter("@AREA_CODE", SqlDbType.NVarChar,50),
                    new SqlParameter("@PROCESS_ID", SqlDbType.NVarChar,50),
                    new SqlParameter("@TACHE_NAME", SqlDbType.NVarChar,50),
                    new SqlParameter("@DEPT_NAME", SqlDbType.NVarChar,50),
                    new SqlParameter("@PROCESS_TIME", SqlDbType.NVarChar,50),
                    new SqlParameter("@PROCESS_NAME", SqlDbType.NVarChar,50),
                    new SqlParameter("@PROCESS_NOTE", SqlDbType.NVarChar,500),
                    new SqlParameter("@CreateTime", SqlDbType.DateTime)};
            parameters[0].Value = model.CASE_SERIAL;
            parameters[1].Value = model.AREA_CODE;
            parameters[2].Value = model.PROCESS_ID;
            parameters[3].Value = model.TACHE_NAME;
            parameters[4].Value = model.DEPT_NAME;
            parameters[5].Value = model.PROCESS_TIME;
            parameters[6].Value = model.PROCESS_NAME;
            parameters[7].Value = model.PROCESS_NOTE;
            parameters[8].Value = model.CreateTime;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.submit_case_process_info model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update submit_case_process_info set ");
            strSql.Append("CASE_SERIAL=@CASE_SERIAL,");
            strSql.Append("AREA_CODE=@AREA_CODE,");
            strSql.Append("PROCESS_ID=@PROCESS_ID,");
            strSql.Append("TACHE_NAME=@TACHE_NAME,");
            strSql.Append("DEPT_NAME=@DEPT_NAME,");
            strSql.Append("PROCESS_TIME=@PROCESS_TIME,");
            strSql.Append("PROCESS_NAME=@PROCESS_NAME,");
            strSql.Append("PROCESS_NOTE=@PROCESS_NOTE,");
            strSql.Append("CreateTime=@CreateTime");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@CASE_SERIAL", SqlDbType.NVarChar,50),
                    new SqlParameter("@AREA_CODE", SqlDbType.NVarChar,50),
                    new SqlParameter("@PROCESS_ID", SqlDbType.NVarChar,50),
                    new SqlParameter("@TACHE_NAME", SqlDbType.NVarChar,50),
                    new SqlParameter("@DEPT_NAME", SqlDbType.NVarChar,50),
                    new SqlParameter("@PROCESS_TIME", SqlDbType.NVarChar,50),
                    new SqlParameter("@PROCESS_NAME", SqlDbType.NVarChar,50),
                    new SqlParameter("@PROCESS_NOTE", SqlDbType.NVarChar,500),
                    new SqlParameter("@CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_ID", SqlDbType.Int,4)};
            parameters[0].Value = model.CASE_SERIAL;
            parameters[1].Value = model.AREA_CODE;
            parameters[2].Value = model.PROCESS_ID;
            parameters[3].Value = model.TACHE_NAME;
            parameters[4].Value = model.DEPT_NAME;
            parameters[5].Value = model.PROCESS_TIME;
            parameters[6].Value = model.PROCESS_NAME;
            parameters[7].Value = model.PROCESS_NOTE;
            parameters[8].Value = model.CreateTime;
            parameters[9].Value = model.F_ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_ID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from submit_case_process_info ");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_IDlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from submit_case_process_info ");
            strSql.Append(" where F_ID in (" + F_IDlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.submit_case_process_info GetModel(int F_ID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_ID,CASE_SERIAL,AREA_CODE,PROCESS_ID,TACHE_NAME,DEPT_NAME,PROCESS_TIME,PROCESS_NAME,PROCESS_NOTE,CreateTime from submit_case_process_info ");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            CallCenterApi.Model.submit_case_process_info model = new CallCenterApi.Model.submit_case_process_info();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.submit_case_process_info DataRowToModel(DataRow row)
        {
            CallCenterApi.Model.submit_case_process_info model = new CallCenterApi.Model.submit_case_process_info();
            if (row != null)
            {
                if (row["F_ID"] != null && row["F_ID"].ToString() != "")
                {
                    model.F_ID = int.Parse(row["F_ID"].ToString());
                }
                if (row["CASE_SERIAL"] != null)
                {
                    model.CASE_SERIAL = row["CASE_SERIAL"].ToString();
                }
                if (row["AREA_CODE"] != null)
                {
                    model.AREA_CODE = row["AREA_CODE"].ToString();
                }
                if (row["PROCESS_ID"] != null)
                {
                    model.PROCESS_ID = row["PROCESS_ID"].ToString();
                }
                if (row["TACHE_NAME"] != null)
                {
                    model.TACHE_NAME = row["TACHE_NAME"].ToString();
                }
                if (row["DEPT_NAME"] != null)
                {
                    model.DEPT_NAME = row["DEPT_NAME"].ToString();
                }
                if (row["PROCESS_TIME"] != null)
                {
                    model.PROCESS_TIME = row["PROCESS_TIME"].ToString();
                }
                if (row["PROCESS_NAME"] != null)
                {
                    model.PROCESS_NAME = row["PROCESS_NAME"].ToString();
                }
                if (row["PROCESS_NOTE"] != null)
                {
                    model.PROCESS_NOTE = row["PROCESS_NOTE"].ToString();
                }
                if (row["CreateTime"] != null && row["CreateTime"].ToString() != "")
                {
                    model.CreateTime = DateTime.Parse(row["CreateTime"].ToString());
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_ID,CASE_SERIAL,AREA_CODE,PROCESS_ID,TACHE_NAME,DEPT_NAME,PROCESS_TIME,PROCESS_NAME,PROCESS_NOTE,CreateTime ");
            strSql.Append(" FROM submit_case_process_info ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_ID,CASE_SERIAL,AREA_CODE,PROCESS_ID,TACHE_NAME,DEPT_NAME,PROCESS_TIME,PROCESS_NAME,PROCESS_NOTE,CreateTime ");
            strSql.Append(" FROM submit_case_process_info ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM submit_case_process_info ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_ID desc");
            }
            strSql.Append(")AS Row, T.*  from submit_case_process_info T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "submit_case_process_info";
			parameters[1].Value = "F_ID";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}